add hooks for commit/push

Signed-off-by: Andy Scherzinger <info@andy-scherzinger.de>
This commit is contained in:
Andy Scherzinger 2022-03-17 13:47:27 +01:00
parent eb67a31bd1
commit 70edda976f
No known key found for this signature in database
GPG Key ID: 6CADC7E3523C308B
2 changed files with 41 additions and 0 deletions

14
scripts/hooks/pre-commit Normal file
View File

@ -0,0 +1,14 @@
#!/bin/bash
# Pre-commit hook: don't allow commits if detekt or ktlint fail. Skip with "git commit --no-verify".
echo "Running pre-commit checks..."
if ! ./gradlew --daemon ktlintCheck &>/dev/null; then
echo >&2 "ktlint failed! Run ./gradlew ktlintCheck for details"
echo >&2 "Hint: fix most lint errors with ./gradlew ktlintFormat"
exit 1
fi
if ! ./gradlew --daemon detekt &>/dev/null; then
echo >&2 "Detekt failed! See report at file://$(pwd)/app/build/reports/detekt/detekt.html"
exit 1
fi

27
scripts/hooks/pre-push Normal file
View File

@ -0,0 +1,27 @@
#!/bin/bash
# Pre-push: Don't allow commits without Signed-off-by. Skip with "git push --no-verify".
set -euo pipefail
z40=0000000000000000000000000000000000000000 # magic deleted ref
while read local_ref local_sha remote_ref remote_sha; do
if [ "$local_sha" != $z40 ]; then
if [ "$remote_sha" = $z40 ]; then
# New branch, examine all commits
range="$(git merge-base master $local_sha)..$local_sha"
else
# Update to existing branch, examine new commits
range="$remote_sha..$local_sha"
fi
# Check for commits without sign-off
commit=$(git rev-list --no-merges --grep 'Signed-off-by' --invert-grep "$range")
if [ -n "$commit" ]; then
echo >&2 "Found commits without sign-off in $local_ref. Aborting push. Offending commits:"
echo >&2 "$commit"
exit 1
fi
fi
done
exit 0